reset;

#const:

pi=3.141592654
obli=23.5*pi/180.

# param:
phi=$0*pi/180.
cophi=pi*.5-phi
j=$1
m=$2
j=(m < 1.1 ? j : j+31) #janv
j=(m < 2.1 ? j : j+28) #fev
j=(m < 3.1 ? j : j+31) #mars
j=(m < 4.1 ? j : j+30) #avr
j=(m < 5.1 ? j : j+31) #mai
j=(m < 6.1 ? j : j+30) #juin
j=(m < 7.1 ? j : j+31) #juil
j=(m < 8.1 ? j : j+31) #aout
j=(m < 9.1 ? j : j+30) #sep
j=(m < 10.1 ? j : j+31) #oct
j=(m < 11.1 ? j : j+30) #nov
lsol=(j-81.)*360./365.25*pi/180. # long. ecli. du soleil

hsv=$3*pi/12.
hsv=(hsv > 2.*pi ? hsv=hsv-2.*pi : hsv)

#fonction:

#modulo
mod(x,y)=x-int(x/y)*y
#place un angle entre -pi et pi
pipi(x)=(mod(x,2.*pi) > pi ? mod(x,2.*pi)-2.*pi : (mod(x,2.*pi) < -pi ? mod(x,2.*pi)+2.*pi : mod(x,2.*pi)))

#coord equatorial d'un point de l'écliptique en fonction de la longitude écliptique:
delta_ecl(l)=asin(sin(l)*sin(obli))
alpha_ecl(l,d)=( sin(l) > 0. ? acos(cos(l)/cos(d)):2.*pi-acos(cos(l)/cos(d)))


# coordonnées équatorial du Soleil

delta_sol(lsol)=delta_ecl(lsol)
alpha_sol(lsol)=alpha_ecl(lsol,delta_sol(lsol))

#temps universel
tu(hsv,lsol)=hsv+alpha_sol(lsol)-pi

#angle horaire en fonction de alpha et tu
ang_hor(hsv,lsol,alpha)=pipi((tu(hsv,lsol)-alpha))

#asc. droite. en fonction de l'angle horaire et de tu
asc_drt(hsv,lsol,h)=tu(hsv,lsol)-h

#declinaison en fonction de alpha pour un point de l'écliptique
delta_ecl2(hsv,lsol,h)=atan(sin(asc_drt(hsv,lsol,h))*tan(obli))


#déclinaison pour un point de l'horizon en fonction de l'angle horaire (le sud a un angle horaire égale à zéro et l'ouest à pi/2
delta_horizon(x,cophi)=atan(sin(-pi*.5-x)*tan(cophi))

#détermine si le soleil est couché ou levé
sinush(phi,lsol,hsv)=sin(phi)*sin(delta_sol(lsol))+cos(phi)*cos(delta_sol(lsol))*cos(hsv-pi)
leve(phi,lsol,hsv)=(sinush(phi,lsol,hsv) > 0 ? 1 : 0) # 1 si levé, 0 si couché

#styles de ligne
set style line 1 lt 1 lw 3 lc rgb "red" #delta = 0 (equateur)
set style line 5 lt 1 lw 3 lc rgb "dark-green" #horizon
set style line 8 lt 1 lw 3 lc rgb "yellow" #eclitpique
set style line 7 lt 1 lw 2 lc rgb "yellow" pt 6 ps 1 #soleil levé
set style line 9 lt 1 lw 2 lc rgb "black" pt 6 ps 1 #soleil couché
set style line 10 lt 1 lw 2 lc rgb "red" pt 6 ps 1 #point vernal
set style line 11 lt 1 lw 2 lc rgb "red" pt 7 ps 0.5 #étoile
set style line 12 lt 1 lw 2 lc rgb "black" pt 7 ps 0.5 #mois

#label
set label "hsv= %.2f h",(hsv*12./pi) at -11.,98. tc rgb "black"
set label "date= %.0f",($1),"/%.0f",($2),"        lat=%.1f",phi*180./pi at  0.,98. center tc rgb "black"


#set grid xtics ytics mxtics mytics front lt 1 lw 0.5 lc rgb "black", lt 3 lw 0.5 lc rgb "black"
#set grid mxtics mytics front lt 2 lc lw 0.5 rgb "black"


#construction repère

set key off

set tmargin 2.

set xrange[-12:12]# reverse
set mxtics 2
set xtics   ("S" 0, "O" 6, "N" 12, "N" -12, "E" -6) tc rgb "white"
#set xlabel 'a' #'ascension droite'

set yrange[-90:90]
#set mytics 2
set ytics -90,20,90
set mytics 2
set ylabel 'd'  #'declinaison'


set multiplot

set origin 0,0;
set size 1,1;

plot 90 w filledc y1=-90  lc rgb (leve(phi,lsol,hsv) == 1 ? "light-blue" :  "dark-blue")



#horizon
plot delta_horizon(x*pi/12.,cophi)*180./pi w filledc y1=(phi > 0.? -90 : 90.)  ls 5

# equateur
plot 0 w l ls 1



#lignes constellations
plot 'coord_const.txt' u (abs(ang_hor(hsv,lsol,($$1)*pi/12.)*12./pi) < 10. ? (ang_hor(hsv,lsol,($$1)*pi/12.)*12./pi):1/0):($$2) w l lc rgb "orange" # constellations


#Etoiles:
replot 'stars4gnuplot.dat'   u (ang_hor(hsv,lsol,$$1*pi/12.)*12./pi):2 w p ls 11

#set label 'Equateur' at  11.5,2 l  front 
#set label 'verseau' at 22,-5 c front 
#set label 'Capricorne' at 21.25,-20 c front 
#set label 'Poisson' at 0.25, 8 ri front 
#set label 'Belier' at 2.5,25 c front 
#set label 'Taureau' at 4, 18 c front 
#set label 'Gemeaux' at 7, 25 c front 
#set label 'Cancer' at 8.75,19 c front 
#set label 'Lion' at 10.75, 15 c front 
#set label 'Vierge' at 13.5,-5 c front 
#set label 'Balance' at 15.15, -15 c front 
#set label 'Scorpion' at 17, -31 c front 
#set label 'Sagittaire' at 19.5, -28 c front 
#set label 'Orion' at 5.75, 3 c front 
#set label 'Pegase' at 23.8,20 l front 
#set label 'Andromede' at 1.5,35 c front 
#set label 'Cassiopee' at 1,60 c front 
#set label 'Petite Ours' at 16.5,80 c front 
#set label 'Grande Oours' at 12,59 c front 
#set label 'Lyre' at 18.8,35 c front 
#set label 'Cygne' at 20.3,38 c front 
#set label 'Hercules' at 17,35 c front 
#set label 'Aigle' at 19.5,8 c front 
#set label 'Croix du Sud' at 12.5,-60 c front 
#set label 'Voile' at 9.5, -45 c front 
#set label 'Carene' at 8.5, -63 c front 
#set label 'Eridan' at 3.5,-35 c front 
#set label 'Grand Chien' at 7,-20 c front 
#set label 'Hydre Femelle' at 10.5,-15 c front 
#set label 'Bouvier' at 14.5,23 c front 
#set label 'Couronne Boreale' at 15.75,28 c front 
#set label 'Dragon' at 16,60 c front 
#set label 'Grue' at 22.75, -45 c front 
#set label 'Phenix' at 0.3,-45 r front 
#set label 'Triangle Austral' at 16,-65 c front 
#set label 'Loup' at 15.5,-40 front 
#set label 'Cocher' at 5.5, 35 c front 
#set label 'Poupe' at 7.5,-40 c front 
#set label 'Paon' at 19.5,-67 c front 
#set label 'Centaure' at 13.5,-45 c front 
#set label 'Lezard' at 22.5,45 c front 
#set label 'Tete du Serpent' at 15.75,10 c front 
#set label 'Queue du Serpent' at 18.25,-8 c front 
#set label 'Ophiucus' at 17.25,3 c front 
#set label 'Persee' at 3.25,45 c   front 

#ecliptique:
plot (delta_ecl2(hsv,lsol,x*pi/12.))*180./pi w l ls 8


#le premier de chaque mois
set param
#janvier
j=1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/1
delta=delta_sol(l)
h=ang_hor(hsv,lsol,alpha_sol(l))
set label "1" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#fevrier
j=1+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/2
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "2" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#mars
j=1+31+28
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/3
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "3" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#avril
j=1+31+28+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/4
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "4" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#mai
j=1+31+28+31+30
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/5
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "5" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#juin
j=1+31+28+31+30+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/6
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "6" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#juillet
j=1+31+28+31+30+31+30
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/7
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "7" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#aout
j=1+31+28+31+30+31+30+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/8
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "8" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#septembre
j=1+31+28+31+30+31+30+31+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/9
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "9" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#octobre
j=1+31+28+31+30+31+30+31+31+30
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/10
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "10" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#novembre
j=1+31+28+31+30+31+30+31+31+30+31
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/11
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "11" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12
#decembre
j=1+31+28+31+30+31+30+31+31+30+31+30
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/12
delta=delta_ecl(l)
h=ang_hor(hsv,lsol,alpha_ecl(l,delta))
set label "12" at (h*12./pi),(delta*180./pi+5.)  center tc rgb "black"
plot (h*12./pi),(delta*180./pi) w p ls 12

#points cardinaux
Az=0.
dd=(phi > 0. ? -6. : +6)
set label "S" at Az,(delta_horizon(Az*pi/12.,cophi)*180./pi + dd) center tc rgb "black"
plot Az,(delta_horizon(Az*pi/12.,cophi)*180./pi) w p pt 7 lc rgb "black"

Az=6.
set label "O" at Az,(delta_horizon(Az*pi/12.,cophi)*180./pi + dd) center tc rgb "black"
plot Az,(delta_horizon(Az*pi/12.,cophi)*180./pi) w p pt 7 lc rgb "black"

Az=12.
set label "N" at Az,(delta_horizon(Az*pi/12.,cophi)*180./pi + dd) right tc rgb "black"
plot Az,(delta_horizon(Az*pi/12.,cophi)*180./pi) w p pt 7 lc rgb "black"

Az=-12.
set label "N" at Az,(delta_horizon(Az*pi/12.,cophi)*180./pi + dd) left tc rgb "black"
plot Az,(delta_horizon(Az*pi/12.,cophi)*180./pi) w p pt 7 lc rgb "black"

Az=-6.
set label "E" at Az,(delta_horizon(Az*pi/12.,cophi)*180./pi + dd) center tc rgb "black"
plot Az,(delta_horizon(Az*pi/12.,cophi)*180./pi) w p pt 7 lc rgb "black"

#Soleil
delta=delta_sol(lsol)
#plot (hsv*12./pi-12.),(delta*180./pi) w p ls (leve(phi,lsol,hsv) == 1 ? 7 : 9 )
plot ang_hor(hsv,lsol,alpha_sol(lsol))*12./pi,(delta*180./pi) w p ls (leve(phi,lsol,hsv) == 1 ? 7 : 9 )

unset multiplot
